license = '''
/* 
Copyright (c) 2019, IIT Madras All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted
provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice, this list of conditions
  and the following disclaimer.  
* Redistributions in binary form must reproduce the above copyright notice, this list of 
  conditions and the following disclaimer in the documentation and/or other materials provided 
  with the distribution.  
* Neither the name of IIT Madras  nor the names of its contributors may be used to endorse or 
  promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS
OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER
IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
--------------------------------------------------------------------------------------------------

This file has been generated by ProtoSynth.
Time of Generation: {0}

*/

'''

enum_decl = '''
typedef enum {{ 
{0}
}} {1} deriving (Eq, Bits, FShow);

'''

union_decl = '''
typedef union tagged {{
{0}
}} {1} deriving(Eq, Bits, FShow);
'''

struct_decl = '''
typedef struct {{
{0}
}} {1} {2} deriving(Eq, Bits, FShow);
'''

params = '''
`define {0} {1}
'''

sv_functions = '''

function {0} fn_Clear({0} sv);
  return 0;
endfunction

function {0} fn_RemoveElement({0} sv, {1} src);
  if ( src matches tagged Caches .c)
    sv[c] = 0;
  return sv;
endfunction

function {0} fn_AddElement({0} sv, {1} src);
  if ( src matches tagged Caches .c)
      sv[c] = 1;
  return sv;
endfunction

function Bool fn_IsElement ({0} sv, {1} i);
  if ( i matches tagged Caches .c)
    return unpack(sv[c]);
  else
    return False;
endfunction

function {2} fn_VectorCount ({0} sv);
  return truncate(pack(countOnes(sv)));
endfunction

'''

cache_return_nonstalling = '''

typedef struct {{
    Bool stall;
    {0} new_cle;
    Maybe#({1}) send_resp1;
    Maybe#({1}) enq_defermsg1;
    Maybe#({1}) enq_defermsg2;
    Bool send_defered;
}} {2}Return {3} deriving(Bits, Eq, FShow);
'''

cache_return_stalling = '''

typedef struct {{
    Bool stall;
    {0} new_cle;
    Maybe#( {1} ) send_resp1;
    Maybe#( {1} ) send_resp2;
}} {2}Return {3} deriving(Bits, Eq, FShow);
'''

directory_return = '''

typedef struct {{
    Bool stall;
    {0} new_cle;
    Maybe#( {1} ) send_resp1;
    Maybe#( {1} ) send_fwd1;
    Maybe#(Tuple2#({1},Bit#(`NrCaches))) send_multicast;
}} {2}Return {3} deriving(Bits, Eq, FShow);
'''
